/* ========================================
 *  SpatializeDither - SpatializeDither.h
 *  Created 8/12/11 by SPIAdmin 
 *  Copyright (c) 2011 __MyCompanyName__, Airwindows uses the MIT license
 * ======================================== */

#ifndef __SpatializeDither_SpatializeDither_H
#define __SpatializeDither_SpatializeDither_H

#include "../../../configuration.h"
#ifdef SHR3D_SFX_CORE_AIRWINDOWS

#include "../common/airwin_consolidated_base.h"


namespace airwinconsolidated::SpatializeDither {
enum {
	kParamA = 0,
	kParamB = 1,
 	kNumParameters = 2
}; //


class SpatializeDither final : public SfxCoreExtensionV1
{
public:
    SpatializeDither();
    ~SpatializeDither();
    void processBlock(float** inputs, float** outputs, int sampleFrames) override;
    int getParameterCount() const override;
    float getParameter(int index) override;
    void setParameter(int index, float value) override;
    void getParameterLabel(int index, char *text) override;
    void getParameterName(int index, char *text) override;
    void getParameterDisplay(int index, char *text) override;
private:
    
	double contingentErrL;
	double contingentErrR;
	bool flip;
	uint32_t fpdL;
	uint32_t fpdR;
	//default stuff
	
    float A;
    float B;
};

} // end namespace

#endif // SHR3D_SFX_CORE_AIRWINDOWS

#endif
